## kernel-diablo 2.6.21-200842maemo1.2

=== Makefile ===

OSSORELEASE = $(shell cat ../osso-release)

DEBIAN_DIR := debian

KSRC = ../linux

KSRCVER = $(shell dpkg-parsechangelog -l$(KSRC)/$(DEBIAN_DIR)/changelog  | awk '/^Version/{print $$2}')
KMAJORVER = $(word 1, $(subst -, ,$(KSRCVER)))
WEEK = $(word 1, $(OSSORELEASE))
BUILD = $(word 2, $(OSSORELEASE))

USER = $(shell whoami)

all: deb

deb: control-stamp changelog-stamp
	dpkg-buildpackage -i'.git/' -I'.git' -rfakeroot -S 

modules:
	fakeroot debian/rules modules-deb

control-stamp: control
	touch control-stamp

control:
	sed -i 's/^Build-Depends-Indep: kernel-source-diablo (=[^)]*)/Build-Depends-Indep: kernel-source-diablo (=$(KSRCVER))/' $(DEBIAN_DIR)/control

changelog-stamp: changelog
	touch changelog-stamp

changelog:
	dch -v $(KMAJORVER)-$(WEEK)osso$(BUILD) "Updated kernel version ($(KSRCVER))"

version:
	dch -i "Custom $(USER) kernel modules version" 

clean:
	rm -f control-stamp changelog-stamp

=== debian/changelog ===
kernel-diablo (2.6.21-200842maemo1.2) unstable; urgency=low

  * Kbuild fix

 -- Grigori Timonen <grigori.timonen@nokia.com>  Sat, 20 Dec 2008 09:36:27 +0200

kernel-diablo (2.6.21-200842maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200842maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 14 Oct 2008 09:32:39 +0300

kernel-diablo (2.6.21-200838maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200838maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Mon, 15 Sep 2008 12:44:46 +0300

kernel-diablo (2.6.21-200837maemo2) unstable; urgency=low

  Updated kernel version 2.6.21-200837maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  9 Sep 2008 12:36:47 +0300

kernel-diablo (2.6.21-200835maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200835maemo1

 -- Timo Poikola <timo.poikola@nokia.com>  Tue, 26 Aug 2008 19:33:25 +0300

kernel-diablo (2.6.21-200834maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200834maemo1

 -- Timo Poikola <timo.poikola@nokia.com>  Wed, 20 Aug 2008 13:35:15 +0300

kernel-diablo (2.6.21-200833maemo3) unstable; urgency=low

  * Updated kernel version 2.6.21-200833maemo3

 -- Jarkko Oikarinen <jarkko.oikarinen@nokia.com>  Wed, 13 Aug 2008 20:12:26 +0300

kernel-diablo (2.6.21-200833maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200833maemo1

 -- Timo Poikola <timo.poikola@nokia.com>  Wed, 13 Aug 2008 12:35:26 +0300

kernel-diablo (2.6.21-200828maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200828maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Wed,  9 Jul 2008 08:38:41 +0300

kernel-diablo (2.6.21-200827maemo1) unstable; urgency=low

  *  Updated kernel version 2.6.21-200827maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  1 Jul 2008 12:48:50 +0300

kernel-diablo (2.6.21-200826maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200826maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Mon, 23 Jun 2008 16:13:16 +0300

kernel-diablo (2.6.21-200823maemo6) unstable; urgency=low

  * Updated kernel version 2.6.21-200823maemo6

 -- Grigori Timonen <grigori.timonen@nokia.com>  Thu, 19 Jun 2008 10:41:35 +0300

kernel-diablo (2.6.21-200823maemo5) unstable; urgency=low

  * Debianizing changes, Fixes: NB#84740

 -- Grigori Timonen <grigori.timonen@nokia.com>  Fri, 13 Jun 2008 11:01:50 +0300

kernel-diablo (2.6.21-200823maemo3) unstable; urgency=low

  * Updated kernel version 2.6.21-200823maemo3

 -- Grigori Timonen <grigori.timonen@nokia.com>  Wed, 11 Jun 2008 14:21:57 +0300

kernel-diablo (2.6.21-200823maemo2) unstable; urgency=low

  * Updated kernel version 2.6.21-200823maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Mon,  9 Jun 2008 12:43:28 +0300

kernel-diablo (2.6.21-200823maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200823maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  3 Jun 2008 11:27:11 +0300

kernel-diablo (2.6.21-200822maemo2) unstable; urgency=low

  * Updated kernel version 2.6.21-200822maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Mon, 26 May 2008 11:55:04 +0300

kernel-diablo (2.6.21-200821maemo2) unstable; urgency=low

  *  Updated kernel version 2.6.21-200821maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 20 May 2008 14:17:28 +0300

kernel-diablo (2.6.21-200820maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200820maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 13 May 2008 14:00:24 +0300

kernel-diablo (2.6.21-200819maemo2) unstable; urgency=low

  *  Updated kernel version 2.6.21-200819maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  6 May 2008 13:43:50 +0300

kernel-diablo (2.6.21-200818maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200818maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Mon, 28 Apr 2008 14:39:14 +0300

kernel-diablo (2.6.21-200817maemo2) unstable; urgency=low

  *  Updated kernel version 2.6.21-200817maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 22 Apr 2008 15:36:57 +0300

kernel-diablo (2.6.21-200816maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200816maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Wed, 16 Apr 2008 08:59:46 +0300

kernel-diablo (2.6.21-200815maemo2extra2) unstable; urgency=low

  * Added kernel-diablo-modules-extra package

 -- Grigori Timonen <grigori.timonen@nokia.com>  Thu, 10 Apr 2008 12:11:09 +0300

kernel-diablo (2.6.21-200815maemo2) unstable; urgency=low

  * Updated kernel version 2.6.21-200815maemo2 

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  8 Apr 2008 11:03:23 +0300

kernel-diablo (2.6.21-200814maemo3) unstable; urgency=low

  * Updated kernel version 2.6.21-200814maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Fri,  4 Apr 2008 10:26:21 +0300

kernel-diablo (2.6.21-200814maemo2) unstable; urgency=low

  * Updated kernel version 2.6.21-200814maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue,  1 Apr 2008 10:37:39 +0300

kernel-diablo (2.6.21-200813maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200813maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 25 Mar 2008 15:03:48 +0200

kernel-diablo (2.6.21-200812maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200812maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 18 Mar 2008 12:56:45 +0200

kernel-diablo (2.6.21-200811maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200811maemo1

 -- Grigori Timonen <grigori.timonen@nokia.com>  Tue, 11 Mar 2008 15:06:21 +0200

kernel-diablo (2.6.21-200809maemo2) unstable; urgency=low

  * Updated kernel version 2.6.21-200809maemo2

 -- Grigori Timonen <grigori.timonen@nokia.com>  Thu, 28 Feb 2008 08:33:44 +0200

kernel-diablo (2.6.21-200809maemo1) unstable; urgency=low

  * Updated kernel version 2.6.21-200809maemo1



=== debian/control ===
Source: kernel-diablo
Section: utils
Priority: optional
Maintainer:  Grigori Timonen <grigori.timonen@nokia.com>
Build-Depends: debhelper (>= 4.0.0)
Build-Depends-Indep: kernel-source-diablo (=2.6.21-200842maemo1)
XBCS-Scratchbox-Architecture: uarm
Standards-Version: 3.8.0

Package: kernel-diablo
Architecture: all
Description: Flashable Linux kernel for RX-34, RX-44, RX-48 hardware
 This package provides a flashable kernel image for RX-34, RX-44, RX-48 HW.

Package: kernel-diablo-flasher
Architecture: all
Depends: flash-and-reboot
XB-Maemo-Flags: flash-and-reboot
Description: Flashable Linux kernel for RX-34, RX-44, RX-48 hardware
 This package provides a flashable kernel image for RX-34, RX-44, RX-48 HW.
 Use the flash-and-reboot utility to flash this kernel.

Package: kernel-diablo-headers
Architecture: all
Depends: ${shlibs:Depends}
Provides: kernel-headers
Description: Linux kernel headers
 This package provides kernel headers for RX-34, RX-44, RX-48.

Package: kernel-diablo-modules
Architecture: all
Description: Linux kernel modules
 This package provides kernel modules for RX-34, RX-44, RX-48.

Package: kernel-diablo-modules-extra
Architecture: all
Description: Linux kernel modules
 This package provides some extra kernel modules for RX-34, RX-44, RX-48.

Package: kernel-diablo-oprofile
Architecture: all
Description: Flashable Linux kernel for RX-48 hardware with oprofile
 This package provides a flashable kernel image for RX-34, RX-44, RX-48 HW.
 It has oprofile support built in.

Package: kernel-diablo-debug
Architecture: all
Description: Linux kernel debug symblos
 This packages provides vmlinux files for the RX-34, RX-44, RX-48 kernels.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

SOURCE_VERSION := $(shell sed -n 's/^Build-Depends-Indep: .*kernel-source-\([^ ]*\).*$$/\1/; t e; b; :e; p; q' debian/control)
WEEK := $(shell date +%Y%W)

KERNELRELEASE = $(shell cat $(CURDIR)/kernel-source-$(SOURCE_VERSION)/include/config/kernel.release 2> /dev/null)

PACKAGE := $(shell sed -n 's/^Source:[\t ]*\([^ ]*\).*$$/\1/; t e; b; :e; p; q' debian/control)
FLASHER_PACKAGE=$(PACKAGE)-flasher
OPROFILE_PACKAGE=$(PACKAGE)-oprofile
DEBUG_PACKAGE=$(PACKAGE)-debug
HEADERS_PACKAGE=$(PACKAGE)-headers
MODULES_PACKAGE=$(PACKAGE)-modules
MODULES_EXTRA_PACKAGE=$(PACKAGE)-modules-extra
KBUILD_PACKAGE=$(PACKAGE)-kbuild

PRODUCT := diablo
DEBIAN_DIR := debian
DEFCONFIG := nokia_2420_defconfig

ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

INCLUDE_HEADERS =  asm asm-generic asm-$(ARCH) Kbuild linux mtd rdma sound acpi config math-emu net rxrpc video keys media pcmcia scsi
MODULES_EXTRA = fs/lockd/lockd.ko fs/nfs/nfs.ko net/sunrpc/sunrpc.ko

HOSTCC=/scratchbox/compilers/cs2005q3.2-glibc2.5-arm/bin/arm-linux-gcc

build: kernel-oprofile kernel headers kernel modules

build-extra: modules-extra

kernel: configure-stamp
	echo "compile $(PRODUCT) kernel"
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ && \
	make HOSTCC=$(HOSTCC) bzImage

kernel-oprofile: configure-oprofile-stamp
	echo "compile $(PRODUCT) oprofile kernel"
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)-oprofile/ && \
	make HOSTCC=$(HOSTCC)

modules: configure-stamp
	echo "compile $(PRODUCT) kernel modules"
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ && \
	make HOSTCC=$(HOSTCC) modules

modules-extra: configure-stamp
	echo "compile $(PRODUCT) kernel EXTRA modules"
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ && \
	patch -p1 < $(CURDIR)/$(DEBIAN_DIR)/modules-extra_config.patch && \
	make HOSTCC=$(HOSTCC) oldconfig modules && \
	patch -p1 -R < $(CURDIR)/$(DEBIAN_DIR)/modules-extra_config.patch && \
	make HOSTCC=$(HOSTCC) oldconfig

headers: modules-extra
	echo "prepare $(PRODUCT) kernel headers"
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ && \
	make HOSTCC=$(HOSTCC) modules_prepare

configure-stamp: sources-stamp
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ && \
	make HOSTCC=$(HOSTCC) $(DEFCONFIG)
	touch $@

configure-oprofile-stamp: sources-oprofile-stamp
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION)-oprofile/ && \
	make HOSTCC=$(HOSTCC) $(DEFCONFIG) && \
	patch -p1 < $(CURDIR)/$(DEBIAN_DIR)/oprofile_config.patch && \
	make HOSTCC=$(HOSTCC) oldconfig
	touch $@

sources-stamp:
	test -d $(CURDIR)/kernel-source-$(SOURCE_VERSION) || tar jxf /usr/src/kernel-source-$(SOURCE_VERSION).tar.bz2
	touch $@

sources-oprofile-stamp: sources-stamp
	cp -a $(CURDIR)/kernel-source-$(SOURCE_VERSION)/ $(CURDIR)/kernel-source-$(SOURCE_VERSION)-oprofile/
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f configure-stamp sources-stamp
	rm -f configure-oprofile-stamp sources-oprofile-stamp
	rm -rf kernel-source-$(SOURCE_VERSION)
	rm -rf kernel-source-$(SOURCE_VERSION)-oprofile
	dh_clean

install: build install-kernel install-kernel-flasher install-modules install-headers install-kernel-oprofile

install-kernel:
	dh_testdir
	dh_testroot
	dh_installdirs

	install $(CURDIR)/kernel-source-$(SOURCE_VERSION)/arch/arm/boot/zImage \
                $(CURDIR)/$(DEBIAN_DIR)/$(PACKAGE)/boot/zImage-$(PRODUCT)-$(WEEK) && \
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION); \
	chmod a-x $(CURDIR)/$(DEBIAN_DIR)/$(PACKAGE)/boot/zImage-$(PRODUCT)-$(WEEK)

install-kernel-flasher:
	dh_testdir
	dh_testroot
	dh_installdirs

	install $(CURDIR)/kernel-source-$(SOURCE_VERSION)/arch/arm/boot/zImage \
                $(CURDIR)/$(DEBIAN_DIR)/$(FLASHER_PACKAGE)/boot/zImage-$(PRODUCT)-$(WEEK) && \
	chmod a-x $(CURDIR)/$(DEBIAN_DIR)/$(FLASHER_PACKAGE)/boot/zImage-$(PRODUCT)-$(WEEK)
	ln -s /boot/zImage-$(PRODUCT)-$(WEEK) $(CURDIR)/$(DEBIAN_DIR)/$(FLASHER_PACKAGE)/etc/flash-and-reboot/kernel

install-kernel-oprofile:
	dh_testdir
	dh_testroot
	dh_installdirs

	install $(CURDIR)/kernel-source-$(SOURCE_VERSION)-oprofile/arch/arm/boot/zImage \
		$(CURDIR)/$(DEBIAN_DIR)/$(OPROFILE_PACKAGE)/boot/zImage-oprofile-$(PRODUCT)-$(WEEK)
	chmod a-x $(CURDIR)/$(DEBIAN_DIR)/$(OPROFILE_PACKAGE)/boot/zImage-oprofile-$(PRODUCT)-$(WEEK)
	install $(CURDIR)/kernel-source-$(SOURCE_VERSION)-oprofile/vmlinux \
		$(CURDIR)/$(DEBIAN_DIR)/$(DEBUG_PACKAGE)/usr/lib/debug/vmlinux-oprofile-$(PRODUCT)-$(WEEK)
	install $(CURDIR)/kernel-source-$(SOURCE_VERSION)/vmlinux \
		$(CURDIR)/$(DEBIAN_DIR)/$(DEBUG_PACKAGE)/usr/lib/debug/vmlinux-$(PRODUCT)-$(WEEK)
	chmod a-x $(CURDIR)/$(DEBIAN_DIR)/$(DEBUG_PACKAGE)/usr/lib/debug/vmlinux-*

install-modules:
	dh_testdir
	dh_testroot

	mkdir -p $(CURDIR)/$(DEBIAN_DIR)/$(MODULES_PACKAGE)/lib/modules/$(KERNELRELEASE)
	for f in $$(find $(CURDIR)/kernel-source-$(SOURCE_VERSION) -name "*.ko"); do \
		install -c -m 644 $$f $(CURDIR)/$(DEBIAN_DIR)/$(MODULES_PACKAGE)/lib/modules/$(KERNELRELEASE)/$$(basename $$f); \
	done
	ln -sf $(KERNELRELEASE) $(CURDIR)/$(DEBIAN_DIR)/$(MODULES_PACKAGE)/lib/modules/current

install-headers:
	dh_testdir
	dh_testroot
	dh_installdirs

	install -d $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/
	cd $(CURDIR)/kernel-source-$(SOURCE_VERSION); \
	install -p -o root -g root -m 644 .config  $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/ && \
	install -p -o root -g root -m 644 Makefile $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/ && \
	install -p -o root -g root -m 644 Module.symvers $(CURDIR)/debian/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/ && \
	install -p -o root -g root -m 644 -D include/config/auto.conf \
		$(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/include/config/auto.conf && \
	find arch/$(ARCH) $(foreach dir,$(INCLUDE_HEADERS),include/$(dir)) -name '*.h' \
		-exec install -D -m644 {} $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/{} \; && \
	find ./ \( -name Makefile -or -name Kbuild -or -name Kconfig\* \) \
		-exec install -D -m644 {} $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/{} \;

	ln -sf asm-$(ARCH) $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/include/asm

	rm -rf $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/scripts
	ln -sf ../$(KBUILD_PACKAGE)/scripts $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)

	cp -a $(CURDIR)/kernel-source-$(SOURCE_VERSION)/include/asm-$(ARCH)/arch \
		$(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/include/asm-$(ARCH)

	cp $(CURDIR)/kernel-source-$(SOURCE_VERSION)/arch/$(ARCH)/kernel/asm-offsets.s \
		$(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(HEADERS_PACKAGE)/arch/$(ARCH)/kernel
#install /lib/modules symlink
	install -d -m 755 $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/lib/modules/$(KERNELRELEASE)/
	ln -sf /usr/src/$(HEADERS_PACKAGE) $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/lib/modules/$(KERNELRELEASE)/build
#install kbuild
	install -d $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(KBUILD_PACKAGE)
	cp -a $(CURDIR)/kernel-source-$(SOURCE_VERSION)/scripts $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(KBUILD_PACKAGE)
#kbuild fixes
	cd $(CURDIR)/$(DEBIAN_DIR)/$(HEADERS_PACKAGE)/usr/src/$(KBUILD_PACKAGE)/scripts && \
		( rm -f $(RM_SCRIPTS); chmod a-x mkcompile_h )

install-modules-extra:
	dh_testdir
	dh_testroot

	mkdir -p $(CURDIR)/$(DEBIAN_DIR)/$(MODULES_EXTRA_PACKAGE)/lib/modules/$(KERNELRELEASE)/extra
	for f in $(MODULES_EXTRA); do \
		install -c -m 644 $(CURDIR)/kernel-source-$(SOURCE_VERSION)/$$f \
			$(CURDIR)/$(DEBIAN_DIR)/$(MODULES_EXTRA_PACKAGE)/lib/modules/$(KERNELRELEASE)/extra/$$(basename $$f); \
	done

install-extra: install-modules-extra

binary-indep: build install build-extra install-extra

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_strip -p$(HEADERS_PACKAGE)
	dh_compress
